<?php
class VPN_UBUNTU{

    public static function Connect_Ubuntu(){
        $aCfg = new aCfg();

        $aCfg->set("VPNBusy",1);

        if(!self::createVPN_Ubuntu()){
            $aCfg->set("statusVPN",0);
            # config dibawah berguna untuk menandai bahwa VPN sudah tidak busy atau tidak sedang connecting
            $aCfg->set("VPNBusy",0);    
            $aCfg->set("IsCekVPNBusy",0);
            return json_encode( array("Jenis"=>1,"MSG"=>"Failed to create vpn")) ;

        }
        self::RouteIP_Ubuntu();

        Func::writeLog("Connecting to AssistVPN");
        
        $output = Func::exec("nmcli connection up AssistVPN");        
        if(Func::InArray("successfully",$output)){            
            $aCfg->set("statusVPN",1);
            $aCfg->set("VPNBusy",0);
            $aCfg->set("IsCekVPNBusy",0);
            return json_encode( array("Jenis"=>1,"MSG"=>"ok")) ;
         }
        # config dibawah berguna untuk menandai bahwa VPN sudah tidak busy atau tidak sedang connecting
        $aCfg->set("statusVPN",0);
        $aCfg->set("IsCekVPNBusy",0);
        $aCfg->set("VPNBusy",0);

        return json_encode( array("Jenis"=>1,"MSG"=>$output)) ;

    }

    private static function createVPN_Ubuntu()
    {
        $aCfg = new aCfg();
        Func::writeLog("create vpn for ubuntu");
        $cUsername = $aCfg->get("Username","");
        $cPassword = $aCfg->get("Password","");
        Func::exec("nmcli connection delete AssistVPN");        
        $cCommand = "nmcli connection add connection.id AssistVPN connection.type vpn connection.interface-name wlp2s0 connection.permissions spameggs vpn.service-type pptp vpn.data gateway=vpn.sis1.net vpn.user-name " . $cUsername . " vpn.secrets password=" . $cPassword . " ipv4.never-default true";  
        $output = Func::exec($cCommand,false);                
        if(Func::InArray("successfully",$output)){                
            return true;
        }   
        return false;
    }


    public static function Disconnect_Ubuntu(){
        $aCfg = new aCfg();
        Func::exec("nmcli connection down AssistVPN");        
        Func::exec("nmcli connection delete AssistVPN");        
        Func::exec("systemctl restart NetworkManager");        
        $aCfg->set("statusVPN",0);
        return json_encode( array("Jenis"=>0,"MSG"=>"ok")) ;
    }

    private static function RouteIP_Ubuntu(){
            $vaIP = Func::getRouteIP();

            $cIP = implode(",",$vaIP);
           
            $cCommand = "nmcli connection modify AssistVPN ipv4.routes '" . $cIP . "' ; ";
            
            Func::writeLog($cCommand);
            Func::exec($cCommand);
    }

    public static function AutoConnect_Ubuntu(){
        return self::Connect_Ubuntu();
    }
}