<?php
include 'aCfg.php'; 
class Func{
    public static function GetTmpDir()
    {
        $cDir = "tmp";
        if (!is_dir($cDir)) {
            mkdir($cDir, 0777);
        }
        $cDir = "tmp/tmp";
        $nDir = date("H") % 3;
        $nDir1 = $nDir + 1;
        if ($nDir1 == 3) {
            $nDir1 = 0;
        }
    
        if (!is_dir($cDir . $nDir)) {
            mkdir($cDir . $nDir, 0777);
        }
    
        return $cDir . $nDir;
    }
    public static function now()
    {
        return time();
    }

    public static function SNow()
    {
        return date("Y-m-d H:i:s");
    }

    public static function GetTmpFile()
    {
        return self::GetTmpDir() . "/" . md5(rand(0, 10000) . self::now() . session_id());
    }
    
    public static function getIDMesin($cMac){
        $IDMesin = "" . $cMac . "_" . date("Y-m-d H:i:s") ;  
        return $IDMesin;
    }

    private static function ISVPNConnect_Windows(){

        
        exec('ipconfig|find /i "VPN"',$output);
        if (!empty($output) && count($output) > 0) {
            return $output[0];
        }
        return ""; 
    }

    private static function ISVPNConnect_Ubuntu(){

        
        exec('nmcli con show --active | grep -i AssistVPN',$output);
        if (!empty($output)) {
            return $output;
        }
        return ""; 
    }

    public static function ISVPNConnect(){
        $cOS = Func::getOS();

        switch ($cOS) {
            case "WINNT":                 
                 return  self::ISVPNConnect_Windows();
            case "Linux":                
                return self::ISVPNConnect_Ubuntu();
            case "Darwin":
                break;
        }
    }
    
    public static function getOS(){
        return PHP_OS;
    }
    
    public static function writeLog($message){
        $cFile= "log.txt";
       
        $cMsg = "";
        if(is_array($message)){
            foreach ($message as $key => $value) {
                # code...
                $cMsg .= self::SNow() . " > " . $value . "\n";
            }
        }else 
        $cMsg = self::SNow(). " > " . $message . "\n";
        file_put_contents($cFile, $cMsg, FILE_APPEND);
    }

    public static function exec($cCommand,$writelog = true){
        # fungsi exec command shell
        if($writelog)
            self::writeLog($cCommand);
        
        exec($cCommand,$output);
        
        if($writelog)
            self::writeLog($output);

        return $output;
    }

    public static function getRouteIP(){
        $vaIP = array();
        $handle = fopen("./include/lib/assist.route", "r");
        if ($handle) {
            while (($line = fgets($handle)) !== false) {
                // process the line read.
                $vaIP[] =  trim(preg_replace('/\s+/', '', $line));
;
            }

            fclose($handle);
        } else {
            // echo "error ";
            // error opening the file.
        } 

        return $vaIP;
    }

    public static function InArray($cData, $vaArray){
        foreach ($vaArray as $key => $value) {
            # code...
            if(strpos($value, $cData) !== false) return true;
        }
        return false;
    }

    public static function GetVersionOS_Windows(){
        $output = Func::exec("ver");            
        $a = $output[count($output)-1];
        return explode("[Version ",$a)[1];
    }

    public static function GetVersionVPNEngine($withOS = true){
        include_once './init.php';
        if($withOS){
            $cOS = Func::getOS();
            switch ($cOS) {
                case "WINNT":                 
                    return  "W".__APP_VERSION__;
                case "Linux":                
                    return "L".__APP_VERSION__;
                case "Darwin":
                    return  "M".__APP_VERSION__;;
            }
        }
        return __APP_VERSION__;
    }
}
