var canShowNotif = true;
var canCheckVPNStatus = true;
function onLoad() {
    console.log(self.parent.window.location);
    canShowNotif = true;

    reqPermsission();
    getMAC();
    getIPAddress();
    ping();
    
    getQR();
    getVPNStatus();
    setInterval(function () {
        ping();
        getVPNStatus(false);
        cekvpn();
    }, 5000);
}

function setLoading() {
    document.getElementById("loader").style.display = "inline-block";
    document.getElementById("qr").style.display = "none";
    document.getElementById("btnDisconnect").style.display = "none";
    document.getElementById("vpnstatus").innerHTML = "Tunggu sebentar..";
    // document.getElementById("btnOTP").style.display = "none";

}

function setConnected() {
    console.log("status connected")
    document.getElementById("loader").style.display = "none";
    document.getElementById("qr").style.display = "none";
    document.getElementById("btnDisconnect").style.display = "inline-block";
    document.getElementById("vpnstatus").innerHTML = "Connected";
    // document.getElementById("btnOTP").style.display = "none";

   

}

function setDisconnected() {
    console.log("status disconnected")
    document.getElementById("loader").style.display = "none";
    document.getElementById("qr").style.display = "inline-block";
    document.getElementById("btnDisconnect").style.display = "none";
    document.getElementById("vpnstatus").innerHTML = "Disconnect";
    // document.getElementById("btnOTP").style.display = "inline-block";

}

function ping() {
    $('#ping').load('ping.php', function (data) {
        console.log("aaa " + data);
    });
}

function getIPAddress() {
    $('#ipaddress').load('getipaddress.php', function (data) {
        console.log("IP Address : " + data);
    });
}

function getMAC() {
    $('#macaddress').load('getmacaddress.php', function (data) {
        console.log("MAC Address : " + data);
    });
}

function getQR() {
    setLoading();
    $('#qr').load('getqr.php', function (data) {
        console.log("QR Genereaterd : " + data);
        $('#qr').src = data;
        document.getElementById("qr").src = data;
        setDisconnected();
    });
}

function getVPNStatus($showStatus = true) {
    console.log("iyeee");
    if(!canCheckVPNStatus) return;

    if ($showStatus) {
        document.getElementById("vpnstatus").innerHTML = "Checking vpn status..";
    }
    $.ajax({
        url: "getvpnstatus.php", //the page containing php script

        success: function (res) {
            console.log("res iyee " + res);
            var result = JSON.parse(res);
            // var btnOTP = document.getElementById("btnOTP");


            if (!result.Connect) {

                // btnOTP.style.display = "inline-block";
                if(result.ShowNotif)  {
                    reconnecting();
                    setLoading();
                    console.log
                }else{
                    setDisconnected();
                }
            } else {
                console.log("test 2 " + result);
                setConnected();
            }
        }
    });
}

function edtivpn(){
    $.ajax({
        url: "editvpnstatus.php", //the page containing php script
        success: function (res) {
           
        }
    });
}


function disconnectstatus(){
    $.ajax({
        url: "disconnectstatus.php", //the page containing php script
        success: function (res) {
           
        }
    });
}

function cekvpn(){
    $.ajax({
        url: "cekvpn.php", //the page containing php script
        success: function (res) {
            console.log("pak rt " + res);
            var vaData = JSON.parse(res);
            switch(vaData.Status){
                case 0:
                    canCheckVPNStatus = false;
                    connect();
                break;
                case 2:
                    canCheckVPNStatus = true;
                    
                break;
                case 1:
                    canCheckVPNStatus = false;
                    disconnect();
                break;
            }
        }
    });
}

function reconnecting(){
    showNotif("Assist VPN","Komputer Anda disconnect dari Assist VPN, mencoba reconnecting");
    setLoading();
    console.log("reconnn");
    document.getElementById("vpnstatus").innerHTML = "reconnecting...";
    $.ajax({
        url: "autoconnect.php", //the page containing php script
        success: function (res) {
            doVPNDoing(res,true);
        }
    });
}

function refreshQR() {
    var nLoop = document.getElementById("nomor").value;
    console.log(nLoop);
    if (nLoop > 5) {
        document.getElementById("nomor").value = 1;
        nLoad = 10;
        upqr = setInterval(generateQR, 1000);
    }
}

var upqr = null;
var nLoad = 30;

function generateQR() {
    nLoad++;
    console.log("load", nLoad);
    if (nLoad >= 30) {
        var nLoop = a.f.nomor.value;
        console.log("iki", nLoop);
        a.ajax('', 'getQR()', a.fContent(), function (cResponse) {
            if (cResponse != "") {
                var vaRow = JSON.parse(cResponse);
                document.getElementById("imgqr").src = vaRow.QRFile;
                a.f.nomor.value = parseInt(nLoop) + 1;

                //membuat chaptcha
                var o = document.getElementById("oCaptCha");
                o.src = "ajax.php?__par=./verify/qrcodescan.img.php&c=" + vaRow.KodeOTP;
                nLoad = 0;
            }
        });

        //}

        /*else{
          clearInterval(upqr);
          console.log("ikiwes 30");
          a.ajax('','getQR()',a.fContent(),function(cResponse){
            document.getElementById("imgqr").src = cResponse;
          });
        }*/
        //LoadCaptCha();

    }
}

function doVPNDoing(response, connectOnFailed = false) {
    var result = JSON.parse(response);
    console.log("uyee" + response);
    if (result.MSG == "ok") {
        if (result.Jenis == 0) {
            setDisconnected();
            showNotif("Disconnect Berhasil", "Berhasil disconnect VPN");
        } else {
            edtivpn();
            setConnected();
            showNotif("Connect Berhasil", "Berhasil melakukan koneksi VPN");
        }
    } else {
        if (result.Jenis == 0) {
            setConnected();
            // alert(result.MSG);
            showNotif("Disconnect Gagal", result.MSG);
        } else {
            if(connectOnFailed){
                canShowNotif = false;
                reconnecting();        
                console.log("reconnneee");

            }else{
                setDisconnected();
                showNotif("Gagal connect ke VPN", result.MSG);
                disconnectstatus();
                alert("Gagal connect ke VPN, erro : " + result.MSG);

            }
            
        }
    }
    canCheckVPNStatus = true;
}

function disconnect(){
    showNotif("Disconnecting Assist VPN","Sistem sedang memutuskan koneksi AssistVPN dari komputer Anda");

    document.getElementById("loader").style.display = "inline-block";
    document.getElementById("qr").style.display = "none";
    document.getElementById("btnDisconnect").style.display = "none";

    //import cert file
    $.ajax({
        url: "disconnect.php", //the page containing php script
        success: function (response) {
            doVPNDoing(response);
        }
    });
}

function connect() {
    showNotif("Connecting Assist VPN","Sistem sedang menyambungkan komputer Anda ke AssistVPN");

    document.getElementById("loader").style.display = "inline-block";
    document.getElementById("qr").style.display = "none";
    document.getElementById("btnDisconnect").style.display = "none";

    //import cert file
    $.ajax({
        url: "connect.php", //the page containing php script
        success: function (response) {
            doVPNDoing(response);
        }
    });
}
 // request permission on page load
 function reqPermsission (){
    if (!Notification) {
        alert('Desktop notifications not available in your browser. Try Chromium.');
        return;
    }

    if (Notification.permission !== 'granted')
        Notification.requestPermission();
}


function showNotif(cTittle,cMessage) {
    if(!canShowNotif) return;
    if (!Notification) {
        alert(cMessage);
        return;
    }
    if (Notification.permission !== 'granted')
        Notification.requestPermission();
    else {
        var notification = new Notification(cTittle, {
            icon: './include/images/logo.jpg',
            body: cMessage,
        });
        // notification.onclick = function () {
        //     window.open('http://stackoverflow.com/a/13328397/1269037');
        // };
    }
}

function btnRefresh(){
    $.ajax({
        url: "refresh.php", //the page containing php script
        success: function (res) {
            console.log(res);
        }
    });
}

function btnLog(){
    console.log("asas");
    $.ajax({
        url: "download.php", //the page containing php script
        success: function (res) {
           console.log(res);
        }
    });
}